# Yahoo! UI Library

### datatype 3.3.0

Yahoo! UI Library > datatype > datatype-xml-parse.js (source view)
Search:
Filters Show Private Show Protected Show Deprecated

    /**
     * Parse XML submodule.
     *
     * @module datatype
     * @submodule datatype-xml-parse
     * @for DataType.XML
     */

    var LANG = Y.Lang;

    Y.mix(Y.namespace("DataType.XML"), {
        /**
         * Converts data to type XMLDocument.
         *
         * @method parse
         * @param data {String} Data to convert.
         * @return {XMLDoc} XML Document.
         */
        parse: function(data) {
            var xmlDoc = null;
            if(LANG.isString(data)) {
                try {
                    if(!LANG.isUndefined(ActiveXObject)) {
                            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
                            xmlDoc.async = false;
                            xmlDoc.loadXML(data);
                    }
                }
                catch(ee) {
                    try {
                        if(!LANG.isUndefined(DOMParser)) {
                            xmlDoc = new DOMParser().parseFromString(data, "text/xml");
                        }
                    }
                    catch(e) {
                    }
                        Y.log(ee.message + " (Could not parse data " + Y.dump(data) + " to type XML Document)", "warn", "datatype-xml");
                }
            }

            if( (LANG.isNull(xmlDoc)) || (LANG.isNull(xmlDoc.documentElement)) || (xmlDoc.documentElement.nodeName === "parsererror") ) {
                Y.log("Could not parse data " + Y.dump(data) + " to type XML Document", "warn", "datatype-xml");
            }

            return xmlDoc;
        }
    });

    // Add Parsers shortcut
    Y.namespace("Parsers").xml = Y.DataType.XML.parse;

Copyright © 2011 Yahoo! Inc. All rights reserved.